; ---------------------------------------------------------------------------
; Object 72 - Modified Teleporter (SBZ)
; ---------------------------------------------------------------------------
;
; Subtype bit field: RPMDDDDD
; R: 0 = No ring requirement | 1 = Requies 50 Rings
; P: 0 = Start point | 1 = Mid point (skips start up animation)
; M: 0 = Moves Sonic up | 1 = Moves Sonic left
; DDDDD: Distance to move Sonic x 40 (A distance of 0 will cause a soft lock)
;
; If the object is mirrored will move Sonic down/right instead of up/left
;
; ---------------------------------------------------------------------------

Teleport:
		moveq	#0,d0
		move.b	obRoutine(a0),d0
		move.w	Tele_Index(pc,d0.w),d1
		jsr	Tele_Index(pc,d1.w)
		out_of_range.s	@delete
		rts	

	@delete:
		jmp	(DeleteObject).l
; ===========================================================================
Tele_Index:		dc.w Tele_Setup-Tele_Index
			dc.w loc_166C8-Tele_Index
			dc.w loc_1675E-Tele_Index
			dc.w loc_16798-Tele_Index
; ===========================================================================
Tele_Setup:				; XREF: Tele_Index
		move.b	#2,$24(a0)

		move.b	$28(a0),d1
		lsl.b		#$3,d1
		lsr.b		#$3,d1

		muls.w	#$40,d1

		btst.b	#0,$22(a0)
		beq.s		Tele_Setup2
		neg.w		d1

Tele_Setup2:
		cmp.w		#$0,d1
		beq.s		Tele_Main3

		btst.b	#$5,$28(a0)
		bne.s		Tele_Main
		bra.b		Tele_Main2


Tele_Main:				; XREF: Tele_Index
		move.w	$8(a0),d0

		sub.w		d1,d0
		move.w	d0,$36(a0)
		move.w	$C(a0),$38(a0)
		rts

Tele_Main2:
		move.w	$C(a0),d0

		sub.w		d1,d0
		move.w	d0,$38(a0)
		move.w	$8(a0),$36(a0)
		rts

Tele_Main3:
		move.b	#$3,$29(a0)

		btst.b	#$5,$28(a0)
		bne.w		Tele_Main4

		move.w	$8(a0),$36(a0)

		move.w	$C(a0),d0
		sub.w		#$20,d0

		btst.b	#1,$22(a0)
		beq.s		Tele_Main3b
		move.w	$C(a0),d0
		add.w		#$20,d0

Tele_Main3b:
		move.w	d0,$38(a0)
		rts

Tele_Main4:
		move.w	$C(a0),$38(a0)

		move.w	$8(a0),d0
		sub.w		#$20,d0

		btst.b	#0,$22(a0)
		beq.s		Tele_Main4b
		move.w	$8(a0),d0
		add.w		#$20,d0

Tele_Main4b:
		move.w	d0,$36(a0)
		rts

loc_166C8:
		lea		($FFFFD000).w,a1
		move.w	8(a1),d0
		sub.w		8(a0),d0
		beq.s		loc_166E0
		addi.w	#$F,d0

loc_166E0:
		cmpi.w	#$10,d0
		bcc.w		locret_1675C
		move.w	$C(a1),d1
		sub.w		$C(a0),d1
		addi.w	#$20,d1
		cmpi.w	#$40,d1
		bcc.s		locret_1675C
		tst.b		($FFFFF7C8).w
		bne.s		locret_1675C
		btst		#7,$28(a0)
		beq.s		loc_1670E
		cmpi.w	#50,($FFFFFE20).w	; does Sonic have 50 or more rings?
		bcs.s		locret_1675C

loc_1670E:
		addq.b	#2,$24(a0)
		move.b	#$81,($FFFFF7C8).w ; lock controls
		move.b	#2,$1C(a1)	; use Sonic's rolling animation
		move.w	#$800,$14(a1)
		move.w	#0,$10(a1)
		move.w	#0,$12(a1)
		bclr		#5,$22(a0)
		bclr		#5,$22(a1)
		bset		#1,$22(a1)
		move.w	8(a0),8(a1)
		move.w	$C(a0),$C(a1)
		clr.b		$32(a0)

		btst		#6,$28(a0)
		bne.s		locret_1675C

		move.w	#$BE,d0
		jsr		(PlaySound_Special).l ;	play Sonic rolling sound

locret_1675C:
		rts	
; ===========================================================================

loc_1675E:				; XREF: Tele_Index
		lea		($FFFFD000).w,a1
		move.b	$32(a0),d0
		addq.b	#2,$32(a0)
		jsr		(CalcSine).l
		asr.w		#5,d0
		move.w	$C(a0),d2
		sub.w		d0,d2
		move.w	d2,$C(a1)

		btst		#6,$28(a0)
		beq.s		loc_1675E_2
		move.b	#$80,$32(a0)

loc_1675E_2:
		cmpi.b	#$80,$32(a0)
		bne.s		locret_16796
		bsr.w		sub_1681C
		addq.b	#2,$24(a0)

		btst		#6,$28(a0)
		bne.s		locret_16796

		move.w	#$BC,d0
		jsr		(PlaySound_Special).l ;	play teleport sound

locret_16796:
		rts	
; ===========================================================================

loc_16798:				; XREF: Tele_Index
		addq.l	#4,sp
		lea		($FFFFD000).w,a1

		subq.b	#1,$2E(a0)
		bpl.w		loc_167DA
		move.w	$36(a0),8(a1)
		move.w	$38(a0),$C(a1)

		cmp.b		#$1,$29(a0)
		bge.s		loc_16798_A

		bra.s		loc_16800

loc_16798_A:
		sub.b		#1,$29(a0)
		bra.w		NextLocation1

; ===========================================================================

loc_167DA:
		move.l	8(a1),d2
		move.l	$C(a1),d3
		move.w	$10(a1),d0
		ext.l		d0
		asl.l		#8,d0
		add.l		d0,d2
		move.w	$12(a1),d0
		ext.l		d0
		asl.l		#8,d0
		add.l		d0,d3
		move.l	d2,8(a1)
		move.l	d3,$C(a1)
		rts	
; ===========================================================================

loc_16800:		;End of teleport sequence
		andi.w	#$7FF,$C(a1)
		clr.b		$24(a0)
		clr.b		($FFFFF7C8).w
		move.w	#0,$10(a1)
		move.w	#$200,$12(a1)
		rts	

; ||||||||||||||| S U B	R O U T	I N E |||||||||||||||||||||||||||||||||||||||


sub_1681C:
		moveq		#0,d0
		move.w	#$1000,d2
		move.w	$36(a0),d0
		sub.w		8(a1),d0
		bge.s		loc_16830
		neg.w		d0
		neg.w		d2

loc_16830:
		moveq		#0,d1
		move.w	#$1000,d3
		move.w	$38(a0),d1
		sub.w		$C(a1),d1
		bge.s		loc_16844
		neg.w		d1
		neg.w		d3

loc_16844:
		cmp.w		d0,d1
		bcs.s		loc_1687A
		moveq		#0,d1
		move.w	$38(a0),d1
		sub.w		$C(a1),d1
		swap		d1
		divs.w	d3,d1
		moveq		#0,d0
		move.w	$36(a0),d0
		sub.w		8(a1),d0
		beq.s		loc_16866
		swap		d0
		divs.w	d1,d0

loc_16866:
		move.w	d0,$10(a1)
		move.w	d3,$12(a1)
		tst.w		d1
		bpl.s		loc_16874
		neg.w		d1

loc_16874:
		move.w	d1,$2E(a0)
		rts	
; ===========================================================================

loc_1687A:
		moveq		#0,d0
		move.w	$36(a0),d0
		sub.w		8(a1),d0
		swap		d0
		divs.w	d2,d0
		moveq		#0,d1
		move.w	$38(a0),d1
		sub.w		$C(a1),d1
		beq.s		loc_16898
		swap		d1
		divs.w	d0,d1

loc_16898:
		move.w	d1,$12(a1)
		move.w	d2,$10(a1)
		tst.w		d0
		bpl.s		loc_168A6
		neg.w		d0

loc_168A6:
		move.w	d0,$2E(a0)
		rts

NextLocation1:
		btst.b	#$5,$28(a0)
		bne.w		NextLocation2

		cmp.b		#$2,$29(a0)
		beq.s		NextLocation1a

		cmp.b		#$1,$29(a0)
		beq.s		NextLocation1b

		sub.w		#$12,$36(a0)
		btst.b	#0,$22(a0)
		beq.s		NextLocation1_2
		add.w		#$24,$36(a0)

NextLocation1_2:
		sub.w		#$2A,$38(a0)
		btst.b	#1,$22(a0)
		beq.s		NextLocation1_3
		add.w		#$54,$38(a0)

NextLocation1_3:
		move.w	#$100,$2E(a0)
		rts

NextLocation1a:
		sub.w		#$2E,$36(a0)
		btst.b	#0,$22(a0)
		beq.s		NextLocation1a_2
		add.w		#$5C,$36(a0)

NextLocation1a_2:
		sub.w		#$12,$38(a0)
		btst.b	#1,$22(a0)
		beq.s		NextLocation1a_3
		add.w		#$24,$38(a0)

NextLocation1a_3:
		move.w	#$100,$2E(a0)
		rts

NextLocation1b:
		sub.w		#$20,$36(a0)
		btst.b	#1,$22(a0)
		beq.s		NextLocation1b_2
		add.w		#$40,$36(a0)

NextLocation1b_2:
		move.w	#$100,$2E(a0)
		rts


NextLocation2:
		cmp.b		#$2,$29(a0)
		beq.s		NextLocation2a

		cmp.b		#$1,$29(a0)
		beq.s		NextLocation2b

		sub.w		#$2A,$36(a0)
		btst.b	#0,$22(a0)
		beq.s		NextLocation2_2
		add.w		#$54,$36(a0)

NextLocation2_2:
		sub.w		#$12,$38(a0)
		btst.b	#1,$22(a0)
		beq.s		NextLocation2_3
		add.w		#$24,$38(a0)

NextLocation2_3:
		move.w	#$100,$2E(a0)
		rts

NextLocation2a:
		sub.w		#$12,$36(a0)
		btst.b	#0,$22(a0)
		beq.s		NextLocation2a_2
		add.w		#$24,$36(a0)

NextLocation2a_2:
		sub.w		#$2E,$38(a0)
		btst.b	#1,$22(a0)
		beq.s		NextLocation2a_3
		add.w		#$5C,$38(a0)

NextLocation2a_3:
		move.w	#$100,$2E(a0)
		rts

NextLocation2b:
		sub.w		#$20,$38(a0)
		btst.b	#1,$22(a0)
		beq.s		NextLocation2b_2
		add.w		#$40,$38(a0)

NextLocation2b_2:
		move.w	#$100,$2E(a0)
		rts
	
; End of function sub_1681C